
    OMIT('_EndOfInclude_',_UltimateSQL_)

!PRAGMA('link(ODBC32.LIB)')                                        

_UltimateSQL_                           EQUATE(1)    

Sybase                                  EQUATE(0)
MS_SQL                                  EQUATE(1)
Postgres                                EQUATE(2)
My_SQL                                  EQUATE(3) 
ODBC_Direct                             EQUATE(4)


BusyHandlingDoNothing                   EQUATE(1)
BusyHandlingOneConnectionPerThread      EQUATE(2)
BusyHandlingRetryOnBusy                 EQUATE(3)
BusyHandlingConnectionLocking           EQUATE(4) 

SQL_HANDLE_ENV                          EQUATE(1)
SQL_HANDLE_DBC                          EQUATE(2)
SQL_HANDLE_STMT                         EQUATE(3)
SQL_HANDLE_DESC                         EQUATE(4)

SQL_SUCCESS                             EQUATE(0)
SQL_SUCCESS_WITH_INFO                   EQUATE(1)
SQL_ERROR                               EQUATE(-1)
SQL_INVALID_HANDLE                      EQUATE(-2)

SQL_NULL_HANDLE                         EQUATE(0)

SQL_ATTR_ODBC_VERSION                   EQUATE(200)

SQL_OV_ODBC2                            EQUATE(2)
SQL_OV_ODBC3                            EQUATE(3)

SQL_COPT_SS_INTEGRATED_SECURITY         EQUATE(1203)

LoginConnections                        Queue,Type
Name                                        STRING(512)
                                        End
!
!--------------------------
!ClarionLive Debug Class
!--------------------------
!--------------------------------------------------------------------------------
!Category: Clarion Live!
!--------------------------------------------------------------------------------
! Debug Class used to begin building your own classes with!
! The OMIT at the top is used to load the class only once, so you do not have to use the "once" statement when you INCLUDE the class in your global includes
!
!--------------------------------------------------------------------------------
UltimateSQL                             CLASS,TYPE,MODULE('UltimateSQL.CLW'),LINK('UltimateSQL.CLW')     !,_ABCLinkMode_),DLL(_ABCDllMode_)
!
!--------------------------------------------------------------------------------
! Add properties here, which are variables
!--------------------------------------------------------------------------------
!Properties
!----------
DebugPrefix                                 STRING(1)   !Prefix for DebugView filtering
ASCIIFileName                               STRING(100)
QueryShowInDebugView                        BYTE(FALSE) ! Set to TRUE to send your Query to DebugView, FALSE to turn it off
QueryAddToClipboard                         BYTE(FALSE) ! Set to TRUE to send your Query to the Clipboard, FALSE to turn it off
QueryAppendToClipboard                      BYTE(FALSE) ! Set to TRUE to send your Query to the Clipboard, FALSE to turn it off

QueryTableName                              STRING(200),PRIVATE  
ErrorShowInDebugView                        BYTE(FALSE) ! Set to TRUE to send your error to DebugView, FALSE to turn it off
ErrorAddToClipboard                         BYTE(FALSE) ! Set to TRUE to send your error to the Clipboard, FALSE to turn it off
ErrorAppendToClipboard                      BYTE(FALSE) ! Set to TRUE to send your error to the Clipboard, FALSE to turn it off
ErrorShowAsMessage                          BYTE(FALSE) ! Set to TRUE to display your error as a Message, FALSE to turn it off

TheDatabaseConnectionString                 STRING(200),PRIVATE 
Catalog                                     STRING(200),PRIVATE
_Driver                                     LONG,PROTECTED            ! 0 = Sybase, 1 = MS SQL 
LoginConnections                            &LoginConnections,PROTECTED

HINT                                        STRING(220)
LOGONSCREEN                                 BYTE(TRUE)
SAVESTOREDPROC                              BYTE(TRUE)
TRUSTEDCONNECTION                           BYTE(FALSE)  
MULTIPLEACTIVERESULTSETS                    BYTE(TRUE)
ALLOWDETAILS                                BYTE(TRUE)
APPENDBUFFER                                LONG
AUTOINC                                     STRING(100)
BINDCOLORDER                                BYTE(0)
BINDCONSTANTS                               BYTE(TRUE)
BUSYHANDLING                                BYTE(3)
BUSYMESSAGE                                 STRING(200)
BUSYRETRIES                                 BYTE(20)
CLIPSTRINGS                                 BYTE(TRUE)
FASTCOLUMNFETCH                             BYTE(TRUE)
FORCEUPPERCASE                              BYTE(FALSE)
GATHERATOPEN                                BYTE(FALSE)
IGNORETRUNCATION                            BYTE(FALSE)
ISOLATIONLEVEL                              BYTE(1)
LOGFILEPATH                                 STRING(220)
LOGFILEMESSAGE                              STRING(220)
NESTING                                     BYTE(TRUE)
ODBCCALL                                    BYTE(TRUE)
ORDERINSELECT                               BYTE(FALSE)
PREAUTOINC                                  BYTE(TRUE)
TURBOSQL                                    BYTE(FALSE)
USEINNERJOIN                                BYTE(TRUE)
VERIFYVIASELECT                             BYTE(FALSE)
WHERE                                       STRING(220)
ZEROISNULL                                  BYTE(TRUE)





!
!--------------------------------------------------------------------------------
! Add Methods here, which are just procedures or functions
!--------------------------------------------------------------------------------
!Methods
!-------
      
AddColumn                                   PROCEDURE(STRING pTable,STRING pColumn,STRING pType,<STRING pLength>,<STRING pOptions>),LONG,PROC
AlterColumn                                 PROCEDURE(STRING pTable,STRING pColumn,STRING pType,<STRING pLength>,<STRING pOptions>),LONG,PROC
Connect                                     PROCEDURE(*STRING pServer,*STRING pUser,*STRING pPassword,*STRING pDatabase,*BYTE pTrusted),STRING,PROC   
Connect                                     PROCEDURE(*STRING pConnectionString),STRING,PROC  !not done 
DropColumn                                  PROCEDURE(STRING pTable,STRING pColumn),LONG,PROC
DropDependencies                            PROCEDURE(STRING pTable,STRING pColumn),LONG,PROC
DropTable                                   PROCEDURE(STRING pTable),LONG,PROC 
DropDatabase                                PROCEDURE(STRING pDatabase),LONG,PROC 
ExecuteScript                               PROCEDURE(STRING pFileName),BYTE,PROC
GetColumnLength                             PROCEDURE(STRING pTable,STRING pColumn),LONG,PROC
GetConnectionInformation                    PROCEDURE(STRING pConnectStr,*LoginConnections pConnectionList,BYTE pTrusted=0),LONG,PROC,PRIVATE 
HandleError                                 PROCEDURE(LONG pErrorCode,STRING pError,LONG pFileErrorCode,STRING pFileError)
Quote                                       PROCEDURE(STRING pText), STRING
RemoveIllegalCharacters                     PROCEDURE(String pString),STRING
SendDriverString                            PROCEDURE(STRING pMessage),STRING,PROC               
SetQueryConnection                          PROCEDURE(STRING pOwnerName,<STRING pQueryTableName>)
TestConnection                              PROCEDURE(STRING Server, STRING USR, STRING PWD, <Byte Trusted>, <*STRING ErrorOut>),BYTE 
TableExists                                 PROCEDURE(STRING pTable,<STRING pCatalog>,<STRING pSchema>),BYTE
Trace                                       PROCEDURE(*FILE pTbl, <STRING pLogfile>)  
Truncate                                    PROCEDURE(STRING pTable),LONG,PROC 

Insert                                      PROCEDURE(*FILE pTbl, BYTE pIncludePK=False, BYTE pGetIdentity=FALSE), LONG, PROC
Update                                      PROCEDURE(*FILE pTbl), BYTE, PROC
Delete                                      PROCEDURE(*FILE pTbl), BYTE, PROC

Construct                                   PROCEDURE()
Destruct                                    PROCEDURE()       

Init                                        PROCEDURE()  
Kill                                        PROCEDURE()

Query                                       FUNCTION (STRING pQuery, <*QUEUE pQ>, <*? pC1>, <*? pC2>, <*? pC3>, <*? pC4>, <*? pC5>, <*? pC6>, <*? pC7>, <*? pC8>, <*? pC9>, <*? pC10>, <*? pC11>, <*? pC12>, <*? pC13>, <*? pC14>, <*? pC15>, <*? pC16>, <*? pC17>,<*? pC18>, <*? pC19>, <*? pC20>, <*? pC21>, <*? pC22>, <*? pC23>, <*? pC24>, <*? pC25>, <*? pC26>, <*? pC27>, <*? pC28>, <*? pC29>, <*? pC30>),BYTE,PROC
MSSQLQuery                                  FUNCTION (STRING pQuery, <*QUEUE pQ>, <*? pC1>, <*? pC2>, <*? pC3>, <*? pC4>, <*? pC5>, <*? pC6>, <*? pC7>, <*? pC8>, <*? pC9>, <*? pC10>, <*? pC11>, <*? pC12>, <*? pC13>, <*? pC14>, <*? pC15>, <*? pC16>, <*? pC17>,<*? pC18>, <*? pC19>, <*? pC20>, <*? pC21>, <*? pC22>, <*? pC23>, <*? pC24>, <*? pC25>, <*? pC26>, <*? pC27>, <*? pC28>, <*? pC29>, <*? pC30>),BYTE,PROC
MySQLQuery                                  FUNCTION (STRING pQuery, <*QUEUE pQ>, <*? pC1>, <*? pC2>, <*? pC3>, <*? pC4>, <*? pC5>, <*? pC6>, <*? pC7>, <*? pC8>, <*? pC9>, <*? pC10>, <*? pC11>, <*? pC12>, <*? pC13>, <*? pC14>, <*? pC15>, <*? pC16>, <*? pC17>,<*? pC18>, <*? pC19>, <*? pC20>, <*? pC21>, <*? pC22>, <*? pC23>, <*? pC24>, <*? pC25>, <*? pC26>, <*? pC27>, <*? pC28>, <*? pC29>, <*? pC30>),BYTE,PROC
ODBCDirectQuery                             FUNCTION (STRING pQuery, <*QUEUE pQ>, <*? pC1>, <*? pC2>, <*? pC3>, <*? pC4>, <*? pC5>, <*? pC6>, <*? pC7>, <*? pC8>, <*? pC9>, <*? pC10>, <*? pC11>, <*? pC12>, <*? pC13>, <*? pC14>, <*? pC15>, <*? pC16>, <*? pC17>,<*? pC18>, <*? pC19>, <*? pC20>, <*? pC21>, <*? pC22>, <*? pC23>, <*? pC24>, <*? pC25>, <*? pC26>, <*? pC27>, <*? pC28>, <*? pC29>, <*? pC30>),BYTE,PROC
PostgresQuery                               FUNCTION (STRING pQuery, <*QUEUE pQ>, <*? pC1>, <*? pC2>, <*? pC3>, <*? pC4>, <*? pC5>, <*? pC6>, <*? pC7>, <*? pC8>, <*? pC9>, <*? pC10>, <*? pC11>, <*? pC12>, <*? pC13>, <*? pC14>, <*? pC15>, <*? pC16>, <*? pC17>,<*? pC18>, <*? pC19>, <*? pC20>, <*? pC21>, <*? pC22>, <*? pC23>, <*? pC24>, <*? pC25>, <*? pC26>, <*? pC27>, <*? pC28>, <*? pC29>, <*? pC30>),BYTE,PROC
SybaseQuery                                 FUNCTION (STRING pQuery, <*QUEUE pQ>, <*? pC1>, <*? pC2>, <*? pC3>, <*? pC4>, <*? pC5>, <*? pC6>, <*? pC7>, <*? pC8>, <*? pC9>, <*? pC10>, <*? pC11>, <*? pC12>, <*? pC13>, <*? pC14>, <*? pC15>, <*? pC16>, <*? pC17>,<*? pC18>, <*? pC19>, <*? pC20>, <*? pC21>, <*? pC22>, <*? pC23>, <*? pC24>, <*? pC25>, <*? pC26>, <*? pC27>, <*? pC28>, <*? pC29>, <*? pC30>),BYTE,PROC

BusyHandling                                PROCEDURE(BYTE pBusyHandling),STRING,PROC
GatherAtOpen                                PROCEDURE(BYTE pTrueFalse),STRING,PROC
IgnoreTruncation                            PROCEDURE(BYTE pTrueFalse),STRING,PROC
MultipleActiveResultSets                    PROCEDURE(BYTE pTrueFalse),STRING,PROC
SaveStoredProcedure                         PROCEDURE(BYTE pTrueFalse),STRING,PROC   
TurboSQL                                    PROCEDURE(BYTE pTrueFalse),STRING,PROC
VerifyViaSelect                             PROCEDURE(BYTE pTrueFalse),STRING,PROC
                                        END    


	_EndOfInclude_
