   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE
  INCLUDE('UltimateSQL.INC'),ONCE
  INCLUDE('UltimateDebug.INC'),ONCE

   MAP
    MODULE('SQLBASE.DLL')
ConnectToSQL           PROCEDURE(STRING pConnectionString),DLL ! 
    END
    MODULE('SQLPROCEDURES.DLL')
TestProcedure          PROCEDURE,DLL                       ! 
CustomerTable          PROCEDURE,DLL                       ! 
    END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('SQLMAIN001.CLW')
Main                   PROCEDURE   !
     END
    ! Declare init functions defined in a different dll
     MODULE('SQLBASE.DLL')
SQLBase:Init           PROCEDURE(<ErrorClass curGlobalErrors>, <INIClass curINIMgr>),DLL
SQLBase:Kill           PROCEDURE,DLL
     END
     MODULE('SQLPROCEDURES.DLL')
SQLProcedures:Init     PROCEDURE(<ErrorClass curGlobalErrors>, <INIClass curINIMgr>),DLL
SQLProcedures:Kill     PROCEDURE,DLL
     END
   END

Glo:ConnectionString STRING(200),EXTERNAL,DLL(_ABCDllMode_)
MSSQL:Server         CSTRING(41)
MSSQL:Database       CSTRING(51)
MSSQL:UserName       CSTRING(21)
MSSQL:Password       CSTRING(16)
MSSQL:Server:Temp    CSTRING(41)
MSSQL:Database:Temp  CSTRING(51)
MSSQL:UserName:Temp  CSTRING(21)
MSSQL:Password:Temp  CSTRING(16)
MSSQL:ConnectionString CSTRING(129)
MSSQL:SaveLogin      BYTE
SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'

!region File Declaration
UCustomer            FILE,DRIVER('MSSQL'),PRE(UCU),BINDABLE,CREATE,THREAD,EXTERNAL(''),DLL(dll_mode) !Ultimate Customer Table
pk_ID                    KEY(UCU:ID),NOCASE,PRIMARY        !                    
Name_Key                 KEY(UCU:Name),DUP,NOCASE          !Key By Name         
Record                   RECORD,PRE()
ID                          LONG                           !                    
Name                        STRING(60)                     !                    
Address                     STRING(60)                     !                    
CityStateZip                STRING(60)                     !                    
Phone                       STRING(20)                     !                    
                         END
                     END                       

!endregion

UltimateSQL_TPLVersion      CSTRING('v.99'),EXTERNAL,DLL(dll_mode)
us_ServerString             STRING(200),EXTERNAL,DLL(dll_mode)
us_UserNameString           STRING(200),EXTERNAL,DLL(dll_mode)
us_PasswordString           STRING(200),EXTERNAL,DLL(dll_mode)
us_DatabaseString           STRING(200),EXTERNAL,DLL(dll_mode)
us_TrustedByte              BYTE(0),EXTERNAL,DLL(dll_mode)
SQL         CLASS(UltimateSQL),EXTERNAL,DLL(dll_mode)
                     END
CLSkel_TplVersion    CSTRING('v.99'),EXTERNAL,DLL(dll_mode)
UD         CLASS(UltimateDebug),EXTERNAL,DLL(dll_mode)
                     END
Access:UCustomer     &FileManager,THREAD,EXTERNAL,DLL(dll_mode) ! FileManager for UCustomer
Relate:UCustomer     &RelationManager,THREAD,EXTERNAL,DLL(dll_mode) ! RelationManager for UCustomer

FuzzyMatcher         FuzzyClass                            ! Global fuzzy matcher
GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               INIClass                              ! Global non-volatile storage manager
GlobalRequest        BYTE,EXTERNAL,DLL(dll_mode),THREAD    ! Exported from a dll, set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE,EXTERNAL,DLL(dll_mode),THREAD    ! Exported from a dll, set to the response from the form
VCRRequest           LONG,EXTERNAL,DLL(dll_mode),THREAD    ! Exported from a dll, set to the request from the VCR buttons

  CODE
  GlobalErrors.Init(GlobalErrorStatus)
  FuzzyMatcher.Init                                        ! Initilaize the browse 'fuzzy matcher'
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)            ! Configure case matching
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)          ! Configure 'word only' matching
  INIMgr.Init('.\SQLMain.INI', NVD_INI)                    ! Configure INIManager to use INI file
   SQL.DebugPrefix = '!'
   SQL.ASCIIFileName = 'DebugLog.txt' 
   SQL.Init()  
   us_ServerString = 'serena\positive'
   us_UserNameString = ''
   us_PasswordString = ''
   us_DatabaseString = 'ADatabase'
   us_TrustedByte = True
   Glo:ConnectionString = SQL.Connect(us_ServerString,us_UserNameString,us_PasswordString,us_DatabaseString,us_TrustedByte)
   SQL.SetQueryConnection(Glo:ConnectionString,'Queries') 
   IF ~SQL.TableExists('UCustomer')
       SQL.ExecuteScript('UCustomer.sql')
   END
   SQL.MultipleActiveResultSets(TRUE)
   SQL.VerifyViaSelect(FALSE)
   SQL.SaveStoredProcedure(FALSE)
   SQL.GatherAtOpen(FALSE)
   SQL.IgnoreTruncation(TRUE)
   SQL.BusyHandling(3)  
   SQL.SendDriverString('/ALLOWDETAILS=TRUE') 
  UD.Init()
  UD.DebugPrefix = '!'
  UD.ASCIIFileName = 'DebugLog.txt' 
  UD.ProcAlertKey = CtrlShiftP
  SQLBase:Init(GlobalErrors, INIMgr)                       ! Initialise dll (ABC)
  SQLProcedures:Init(GlobalErrors, INIMgr)                 ! Initialise dll (ABC)
  Main
  INIMgr.Update
  SQLBase:Kill()                                           ! Kill dll (ABC)
  SQLProcedures:Kill()                                     ! Kill dll (ABC)
  UD.Kill()
  INIMgr.Kill                                              ! Destroy INI manager
  FuzzyMatcher.Kill                                        ! Destroy fuzzy matcher

