  MEMBER('SQLBase.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
SQLBase_BC0:DctInit    PROCEDURE
SQLBase_BC0:DctKill    PROCEDURE
SQLBase_BC0:FilesInit  PROCEDURE
  END

Hide:Access:UCustomer CLASS(FileManager),TYPE              ! FileManager for UCustomer
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
PreInsert              PROCEDURE(SIGNED OpCode,UNSIGNED AddLen,*CSTRING ErrCode,*CSTRING ErrMsg),BYTE,DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:UCustomer CLASS(RelationManager),TYPE          ! RelationManager for UCustomer
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


_Hide:Access:UCustomer &Hide:Access:UCustomer,AUTO,THREAD
_Hide:Relate:UCustomer &Hide:Relate:UCustomer,AUTO,THREAD


SQLBase_BC0:DctInit PROCEDURE
  CODE
  _Hide:Access:UCustomer &= NEW(Hide:Access:UCustomer)
  _Hide:Relate:UCustomer &= NEW(Hide:Relate:UCustomer)
  Relate:UCustomer &= _Hide:Relate:UCustomer


SQLBase_BC0:FilesInit PROCEDURE
  CODE
  _Hide:Relate:UCustomer.Init


SQLBase_BC0:DctKill PROCEDURE
  CODE
  _Hide:Relate:UCustomer.Kill
  DISPOSE(_Hide:Relate:UCustomer)


Hide:Relate:UCustomer.Init PROCEDURE
  CODE
  _Hide:Access:UCustomer.Init
  SELF.Init(Access:UCustomer,1)


Hide:Access:UCustomer.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= UCU:Record
  SELF.FileNameValue = 'UCustomer'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= UCustomer
  PARENT.Init
  Access:UCustomer &= SELF


Hide:Access:UCustomer.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:UCustomer &= NULL                                 ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:UCustomer.PreInsert PROCEDURE(SIGNED OpCode,UNSIGNED AddLen,*CSTRING ErrCode,*CSTRING ErrMsg)

ReturnValue          BYTE,AUTO

Buffer LIKE(UCU:RECORD)
  CODE
  PUSHERRORS()
  IF SELF.SavePreviousBuffer AND NOT(SELF.PreviousBuffer &= NULL)
     Buffer = SELF.PreviousBuffer
  END
  UCustomer{PROP:ServerAutoInc}
  UCustomer{PROP:ServerAutoInc,1}=1 !UCU:ID
  ReturnValue = PARENT.PreInsert(OpCode,AddLen,ErrCode,ErrMsg)
  POPERRORS()
  RETURN ReturnValue


Hide:Access:UCustomer.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(UCustomer,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(UCU:pk_ID,'UCU:pk_ID',0)
    SELF.AddKey(UCU:Name_Key,'Key By Name',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:UCustomer.Kill PROCEDURE

  CODE
  _Hide:Access:UCustomer.Kill                              ! Kill the file manager
  PARENT.Kill
  Relate:UCustomer &= NULL                                 ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:UCustomer)                          ! destroy the file manager

