   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('EFOCUS.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE
  INCLUDE('UltimateDebug.INC'),ONCE
  INCLUDE('UltimateSQL.INC'),ONCE

   MAP
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('SQLPROCEDURES001.CLW')
TestProcedure          PROCEDURE   !
CustomerTable          PROCEDURE   !Browse the UCustomer file
AlterColumn            PROCEDURE   !
CustomerForm           PROCEDURE   !
     END
    ! Declare functions defined in this DLL
SQLProcedures:Init     PROCEDURE(<ErrorClass curGlobalErrors>, <INIClass curINIMgr>)
SQLProcedures:Kill     PROCEDURE
    ! Declare init functions defined in a different dll
     MODULE('SQLBASE.DLL')
SQLBase:Init           PROCEDURE(<ErrorClass curGlobalErrors>, <INIClass curINIMgr>),DLL
SQLBase:Kill           PROCEDURE,DLL
     END
   END

Glo:ConnectionString STRING(200),EXTERNAL,DLL(_ABCDllMode_)
SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'

!region File Declaration
UCustomer            FILE,DRIVER('MSSQL'),PRE(UCU),BINDABLE,CREATE,THREAD,EXTERNAL(''),DLL(dll_mode) !Ultimate Customer Table
pk_ID                    KEY(UCU:ID),NOCASE,PRIMARY        !                    
Name_Key                 KEY(UCU:Name),DUP,NOCASE          !Key By Name         
Record                   RECORD,PRE()
ID                          LONG                           !                    
Name                        STRING(60)                     !                    
Address                     STRING(60)                     !                    
CityStateZip                STRING(60)                     !                    
Phone                       STRING(20)                     !                    
                         END
                     END                       

!endregion

CLSkel_TplVersion    CSTRING('v.99'),EXTERNAL,DLL(dll_mode)
UD         CLASS(UltimateDebug),EXTERNAL,DLL(dll_mode)
                     END
UltimateSQL_TPLVersion      CSTRING('v.99'),EXTERNAL,DLL(dll_mode)
us_ServerString             STRING(200),EXTERNAL,DLL(dll_mode)
us_UserNameString           STRING(200),EXTERNAL,DLL(dll_mode)
us_PasswordString           STRING(200),EXTERNAL,DLL(dll_mode)
us_DatabaseString           STRING(200),EXTERNAL,DLL(dll_mode)
us_TrustedByte              BYTE(0),EXTERNAL,DLL(dll_mode)
SQL         CLASS(UltimateSQL),EXTERNAL,DLL(dll_mode)
                     END
Access:UCustomer     &FileManager,THREAD,EXTERNAL,DLL      ! FileManager for UCustomer
Relate:UCustomer     &RelationManager,THREAD,EXTERNAL,DLL  ! RelationManager for UCustomer

GlobalRequest        BYTE,EXTERNAL,DLL,THREAD              ! Exported from a dll, set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE,EXTERNAL,DLL,THREAD              ! Exported from a dll, set to the response from the form
VCRRequest           LONG,EXTERNAL,DLL,THREAD              ! Exported from a dll, set to the request from the VCR buttons
FuzzyMatcher         FuzzyClass                            ! Global fuzzy matcher
LocalErrorStatus     ErrorStatusClass,THREAD
LocalErrors          ErrorClass
LocalINIMgr          INIClass
GlobalErrors         &ErrorClass
INIMgr               &INIClass
DLLInitializer       CLASS                                 ! An object of this type is used to initialize the dll, it is created in the generated bc module
Construct              PROCEDURE
Destruct               PROCEDURE
                     END

  CODE
DLLInitializer.Construct PROCEDURE


  CODE
  LocalErrors.Init(LocalErrorStatus)
  LocalINIMgr.Init('.\SQLProcedures.INI', NVD_INI)         ! Initialize the local INI manager to use windows INI file
  INIMgr &= LocalINIMgr
  IF GlobalErrors &= NULL
    GlobalErrors &= LocalErrors                            ! Assign local managers to global managers
  END
  FuzzyMatcher.Init                                        ! Initilaize the browse 'fuzzy matcher'
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)            ! Configure case matching
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)          ! Configure 'word only' matching
  UD.Init()
  UD.DebugPrefix = '!'
  UD.ASCIIFileName = 'DebugLog.txt' 
  UD.ProcAlertKey = CtrlShiftP
   SQL.DebugPrefix = '!'
   SQL.ASCIIFileName = 'DebugLog.txt' 
   SQL.Init()  
  
!These procedures are used to initialize the DLL. It must be called by the main executable when it starts up
SQLProcedures:Init PROCEDURE(<ErrorClass curGlobalErrors>, <INIClass curINIMgr>)
SQLProcedures:Init_Called    BYTE,STATIC

  CODE
  IF SQLProcedures:Init_Called
     RETURN
  ELSE
     SQLProcedures:Init_Called = True
  END
  IF ~curGlobalErrors &= NULL
    GlobalErrors &= curGlobalErrors
  END
  IF ~curINIMgr &= NULL
    INIMgr &= curINIMgr
  END
  Access:UCustomer.SetErrors(GlobalErrors)
  SQLBase:Init(curGlobalErrors, curINIMgr)                 ! Initialise dll - (ABC) -

!This procedure is used to shutdown the DLL. It must be called by the main executable before it closes down

SQLProcedures:Kill PROCEDURE
SQLProcedures:Kill_Called    BYTE,STATIC

  CODE
  IF SQLProcedures:Kill_Called
     RETURN
  ELSE
     SQLProcedures:Kill_Called = True
  END
  SQLBase:Kill()                                           ! Kill dll - (ABC) -
  

DLLInitializer.Destruct PROCEDURE

  CODE
  UD.Kill()
  FuzzyMatcher.Kill                                        ! Destroy fuzzy matcher
  LocalINIMgr.Kill                                         ! Kill local managers and assign NULL to global refernces
  INIMgr &= NULL                                           ! It is an error to reference these object after this point
  GlobalErrors &= NULL


