

   MEMBER('SQLProcedures.clw')                             ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE
   INCLUDE('BRWEXT.INC'),ONCE

                     MAP
                       INCLUDE('SQLPROCEDURES001.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! </summary>
TestProcedure PROCEDURE 


InDebugView          BYTE(1)                               !
AddToClipboard       BYTE                                  !
AppendToClipboard    BYTE                                  !
DisplayMessage       BYTE                                  !
TableName            STRING('UCustomer {11}')              !
Server               STRING(200)                           !
User                 STRING(200)                           !
Password             STRING(200)                           !
Database             STRING(200)                           !
q                    QUEUE,PRE()                           !
Field1               STRING(60)                            !
Field2               STRING(60)                            !
Field3               STRING(60)                            !
Field4               STRING(60)                            !
Field5               STRING(60)                            !
Field6               STRING(60)                            !
Field7               STRING(60)                            !
Field8               STRING(60)                            !
Field9               STRING(60)                            !
Field10              STRING(60)                            !
Field11              STRING(60)                            !
Field12              STRING(60)                            !
Field13              STRING(60)                            !
Field14              STRING(60)                            !
Field15              STRING(60)                            !
Field16              STRING(60)                            !
                     END                                   !
TheQuery             STRING(2000)                          !
NumberOfRecords      LONG                                  !
LocEnableEnterByTab  BYTE(1)                               !Used by the ENTER Instead of Tab template
EnterByTabManager    EnterByTabClass
Window               WINDOW('Connect'),AT(,,468,269),CENTER,GRAY,MDI,SYSTEM
                       TEXT,AT(40,10,241,52),USE(TheQuery),VSCROLL
                       LIST,AT(39,116,406,97),USE(?ListQ),HVSCROLL,FORMAT('64L(2)|M~Field 1~L(0)@s60@64L(2)|M~' & |
  'Field 2~L(0)@s60@64L(2)|M~Field 3~L(0)@s60@64L(2)|M~Field 4~L(0)@s60@64L(2)|M~Field ' & |
  '5~L(0)@s60@64L(2)|M~Field 6~L(0)@s60@64L(2)|M~Field 7~L(0)@s60@64L(2)|M~Field 8~L(0)' & |
  '@s60@64L(2)|M~Field 9~L(0)@s60@64L(2)|M~Field 10~L(0)@s60@64L(2)|M~Field 11~L(0)@s60' & |
  '@64L(2)|M~Field 12~L(0)@s60@64L(2)|M~Field 13~L(0)@s60@64L(2)|M~Field 14~L(0)@s60@64' & |
  'L(2)|M~Field 15~L(0)@s60@64L(2)|M~Field 16~L(0)@s60@'),FROM(q)
                       STRING('Query:'),AT(12,10),USE(?STRING1)
                       STRING('Results:'),AT(6,116),USE(?STRING2)
                       BUTTON('Send'),AT(241,66,40),USE(?BUTTON2)
                       PROMPT('Number Of Records:'),AT(320,79),USE(?NumberOfRecords:Prompt)
                       ENTRY(@n-14),AT(386,78,60,10),USE(NumberOfRecords),RIGHT(1),FLAT,READONLY,TRN
                       PROMPT('Enter a valid SQL Query and click SEND.  Note that you cannot use a "*" in your' & |
  ' SELECT statement, you must specify field names.'),AT(288,10,178,30),USE(?PROMPT2)
                       PROMPT('Example: Select Name From Customer'),AT(288,43,166,12),USE(?PROMPT3)
                       BUTTON('Add/Alter/Delete Column'),AT(350,226,95),USE(?BUTTON3)
                       BUTTON('Execute Script'),AT(350,243,95,15),USE(?BUTTONExecuteScript)
                       GROUP('Error Handling'),AT(37,66,190,42),USE(?GROUP1),BOXED
                       END
                       CHECK('Show  In Debug View'),AT(50,80),USE(InDebugView)
                       CHECK(' Display Message'),AT(50,92),USE(DisplayMessage)
                       CHECK(' Add To Clipboard'),AT(132,80),USE(AddToClipboard)
                       CHECK(' Append To Clipboard'),AT(132,92),USE(AppendToClipboard)
                       BUTTON('Drop Table UCustomer'),AT(37,226,96),USE(?BUTTONDropTable)
                       BUTTON('Create Table (Runs Script)'),AT(37,244),USE(?BUTTONCreateTable)
                       BUTTON('Truncate UCustomer Table'),AT(142,226,98,15),USE(?BUTTONTable)
                       PROMPT('Table Name:'),AT(145,248),USE(?TableName:Prompt)
                       ENTRY(@s20),AT(188,248,60,10),USE(TableName),LEFT
                       BUTTON('Check If Exists'),AT(254,248,64,10),USE(?BUTTONCheckExists)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
ChangeAction           PROCEDURE(),BYTE,DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------
SetErrorHandling                        ROUTINE
    
    SQL.ErrorShowInDebugView   = InDebugView 
    SQL.ErrorShowAsMessage     = DisplayMessage
    SQL.ErrorAddToClipboard    = AddToClipboard
    SQL.ErrorAppendToClipboard = AppendToClipboard

ThisWindow.Ask PROCEDURE

  CODE
  PARENT.Ask
   


ThisWindow.ChangeAction PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.ChangeAction()
                                         
  RETURN ReturnValue


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('TestProcedure')
                 
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?TheQuery
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF UD.ProcedureInfoToDebugView    
        UD.Debug(FORMAT('TestProcedure',@S30) & FORMAT(UD.SetShortApplicationName('SQLProcedures','DLL'),@S20) & ' Last Modified: ' & '05/04/2012 @ 12:34PM') 
  END
  SELF.Open(Window)                                        ! Open window
  Do DefineListboxStyle
  Window{Prop:Alrt,255} = CtrlShiftP   
  SELF.SetAlerts()
  EnterByTabManager.Init(False)
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
           
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?BUTTON2
      ThisWindow.Update
        SQL.Query(CLIP(TheQuery),q,q.Field1,q.Field2,q.Field3,q.Field4,q.Field5,q.Field6,q.Field7,q.Field8,q.Field9,q.Field10,q.Field11,q.Field12,q.Field13,q.Field14,q.Field15,q.Field16)
                                                                                                                                                                                            
        NumberOfRecords = RECORDS(q)
        DISPLAY()
                
            
      
    OF ?BUTTON3
      ThisWindow.Update
      AlterColumn()
    OF ?BUTTONExecuteScript
      ThisWindow.Update
        SQL.QueryAddToClipboard = TRUE
        SQL.ExecuteScript('h:\prm\triggers\prmdatabase.scr')
    OF ?InDebugView
      DO SetErrorHandling   
    OF ?DisplayMessage
      DO SetErrorHandling   
    OF ?AddToClipboard
      DO SetErrorHandling   
    OF ?AppendToClipboard
      DO SetErrorHandling   
    OF ?BUTTONDropTable
      ThisWindow.Update
      SQL.DropTable('UCustomer')
    OF ?BUTTONCreateTable
      ThisWindow.Update
      SQL.ExecuteScript('UCustomer.sql')
    OF ?BUTTONTable
      ThisWindow.Update
      SQL.Truncate('uCustomer')
    OF ?BUTTONCheckExists
      ThisWindow.Update
        SQL.QueryShowInDebugView = TRUE
        EXECUTE SQL.TableExists(TableName) + 1
          MESSAGE('Table Does Not Exist')
          MESSAGE('Table Does Exist!')
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
       IF KEYCODE()=CtrlShiftP AND EVENT() = Event:PreAlertKey
          CYCLE
       END
       IF KEYCODE()=CtrlShiftP  
              UD.ShowProcedureInfo('TestProcedure',UD.SetApplicationName('SQLProcedures','DLL'),Window{PROP:Hlp},'03/31/2012 @ 10:40AM','05/04/2012 @ 12:34PM','05/04/2012 @ 12:34PM')  
          CYCLE
       END
  IF EnterByTabManager.TakeEvent()
     RETURN(Level:Notify)
  END
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

!!! <summary>
!!! Generated from procedure template - Window
!!! Browse the UCustomer file
!!! </summary>
CustomerTable PROCEDURE 

            !
CurrentTab           STRING(80)                            !
Trace                BYTE                                  !
BRW1::View:Browse    VIEW(UCustomer)
                       PROJECT(UCU:Name)
                       PROJECT(UCU:Address)
                       PROJECT(UCU:CityStateZip)
                       PROJECT(UCU:Phone)
                       PROJECT(UCU:ID)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
UCU:Name               LIKE(UCU:Name)                 !List box control field - type derived from field
UCU:Address            LIKE(UCU:Address)              !List box control field - type derived from field
UCU:CityStateZip       LIKE(UCU:CityStateZip)         !List box control field - type derived from field
UCU:Phone              LIKE(UCU:Phone)                !List box control field - type derived from field
UCU:ID                 LIKE(UCU:ID)                   !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
LocEnableEnterByTab  BYTE(1)                               !Used by the ENTER Instead of Tab template
EnterByTabManager    EnterByTabClass
QuickWindow          WINDOW('Browse the UCustomer file'),AT(,,541,282),FONT('MS Sans Serif',8,,FONT:regular,CHARSET:DEFAULT), |
  RESIZE,CENTER,GRAY,IMM,MDI,HLP('CustomerTable'),SYSTEM
                       LIST,AT(21,25,334,146),USE(?Browse:1),HVSCROLL,FORMAT('80L(2)|M~Name~@s60@80L(2)|M~Addr' & |
  'ess~@s60@80L(2)|M~City State Zip~@s60@80L(2)|M~Phone~@s20@'),FROM(Queue:Browse:1),IMM,MSG('Browsing t' & |
  'he UCustomer file')
                       GROUP('SQL Insert/Change/Delete'),AT(13,212,276,54),USE(?GROUP2),BOXED
                         BUTTON('Insert Using SQL'),AT(19,231,81),USE(?BUTTONSQLInsert)
                         BUTTON('Change Using SQL'),AT(110,231,81,14),USE(?BUTTONSQLChange)
                         BUTTON('Delete Using SQL'),AT(201,231,81,14),USE(?BUTTONSQLDelete)
                       END
                       GROUP('Standard Clarion Insert/Change/Delete'),AT(311,212,191,54),USE(?GROUP1),BOXED
                         BUTTON('&Insert'),AT(341,231,42,12),USE(?Insert)
                         BUTTON('&Delete'),AT(443,231,42,12),USE(?Delete)
                         BUTTON('&Change'),AT(392,231,42,12),USE(?Change)
                       END
                       BUTTON('&Close'),AT(471,11,60,22),USE(?Close),LEFT,ICON('WACLOSE.ICO'),MSG('Close Window'), |
  TIP('Close Window')
                       CHECK(' Trace'),AT(367,162),USE(Trace)
                     END

BRW1::AutoSizeColumn CLASS(AutoSizeColumnClassType)
               END
ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::EIPManager     BrowseEIPManager                      ! Browse EIP Manager for Browse using ?Browse:1
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('CustomerTable')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF UD.ProcedureInfoToDebugView    
        UD.Debug(FORMAT('CustomerTable',@S30) & FORMAT(UD.SetShortApplicationName('SQLProcedures','DLL'),@S20) & ' Last Modified: ' & '05/04/2012 @ 12:34PM') 
  END
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
        
  Relate:UCustomer.Open                                    ! File UCustomer used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:UCustomer,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  ?Browse:1{Prop:LineHeight} = 14
  Do DefineListboxStyle
  QuickWindow{Prop:Alrt,255} = CtrlShiftP   
  BRW1.Q &= Queue:Browse:1
  BRW1.AddSortOrder(,UCU:Name_Key)                         ! Add the sort order for UCU:Name_Key for sort order 1
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort0:Locator.Init(,UCU:Name,1,BRW1)               ! Initialize the browse locator using  using key: UCU:Name_Key , UCU:Name
  BRW1.AddField(UCU:Name,BRW1.Q.UCU:Name)                  ! Field UCU:Name is a hot field or requires assignment from browse
  BRW1.AddField(UCU:Address,BRW1.Q.UCU:Address)            ! Field UCU:Address is a hot field or requires assignment from browse
  BRW1.AddField(UCU:CityStateZip,BRW1.Q.UCU:CityStateZip)  ! Field UCU:CityStateZip is a hot field or requires assignment from browse
  BRW1.AddField(UCU:Phone,BRW1.Q.UCU:Phone)                ! Field UCU:Phone is a hot field or requires assignment from browse
  BRW1.AddField(UCU:ID,BRW1.Q.UCU:ID)                      ! Field UCU:ID is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  SELF.SetAlerts()
  BRW1::AutoSizeColumn.Init()
  BRW1::AutoSizeColumn.AddListBox(?Browse:1,Queue:Browse:1)
  EnterByTabManager.Init(False)
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:UCustomer.Close
  END
  BRW1::AutoSizeColumn.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?BUTTONSQLInsert
      ThisWindow.Update
      GlobalRequest = InsertRecord
      CustomerForm()
      ThisWindow.Reset
        BRW1.ResetFromFile
    OF ?BUTTONSQLChange
      ThisWindow.Update
      GlobalRequest = ChangeRecord
      CustomerForm()
      ThisWindow.Reset
        BRW1.ResetFromFile
    OF ?BUTTONSQLDelete
      ThisWindow.Update
        SQL.Delete(UCustomer)
        BRW1.ResetQueue(Reset:Queue)
    OF ?Trace
      EXECUTE Trace + 1
          SQL.Trace(UCustomer)
          SQL.Trace(UCustomer,'UCustomerLog.txt')
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
       IF KEYCODE()=CtrlShiftP AND EVENT() = Event:PreAlertKey
          CYCLE
       END
       IF KEYCODE()=CtrlShiftP  
              UD.ShowProcedureInfo('CustomerTable',UD.SetApplicationName('SQLProcedures','DLL'),QuickWindow{PROP:Hlp},'04/16/2012 @ 09:44PM','05/04/2012 @ 12:34PM','05/04/2012 @ 12:34PM')  
          CYCLE
       END
  IF EnterByTabManager.TakeEvent()
     RETURN(Level:Notify)
  END
  IF BRW1::AutoSizeColumn.TakeEvents()
     RETURN Level:Notify
  END
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.EIP &= BRW1::EIPManager                             ! Set the EIP manager
  SELF.DeleteAction = EIPAction:Always
  SELF.ArrowAction = EIPAction:Default+EIPAction:Remain+EIPAction:RetainColumn
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete
  END


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window

!!! <summary>
!!! Generated from procedure template - Window
!!! </summary>
AlterColumn PROCEDURE 

   !
Column               STRING(60)                            !
Type                 STRING(20)                            !
Length               STRING(20)                            !
Options              STRING(20)                            !
LocEnableEnterByTab  BYTE(1)                               !Used by the ENTER Instead of Tab template
EnterByTabManager    EnterByTabClass
Window               WINDOW('Add/Alter Column'),AT(,,307,156),CENTER,GRAY,MDI,SYSTEM
                       PROMPT('Column:'),AT(51,40),USE(?Column:Prompt)
                       ENTRY(@s60),AT(84,40,164,10),USE(Column),LEFT
                       PROMPT('Type:'),AT(58,54),USE(?Type:Prompt)
                       ENTRY(@s20),AT(84,54,60,10),USE(Type),LEFT
                       PROMPT('Length:'),AT(54,68),USE(?Length:Prompt)
                       ENTRY(@s20),AT(84,68,60,10),USE(Length),LEFT
                       PROMPT('Options:'),AT(51,82),USE(?Options:Prompt)
                       ENTRY(@s20),AT(84,82,60,10),USE(Options),LEFT
                       BUTTON('Create Column'),AT(84,126),USE(?BUTTONCreateColumn)
                       PROMPT('This will create a new Column in the UCustomer Table'),AT(14,8),USE(?PROMPT1)
                       BUTTON('Alter Column'),AT(152,126,61,14),USE(?BUTTONAlterColumn)
                       BUTTON('Remove Column'),AT(223,126,61,14),USE(?BUTTONRemoveColumn)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('AlterColumn')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Column:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF UD.ProcedureInfoToDebugView    
        UD.Debug(FORMAT('AlterColumn',@S30) & FORMAT(UD.SetShortApplicationName('SQLProcedures','DLL'),@S20) & ' Last Modified: ' & '05/04/2012 @ 12:34PM') 
  END
  SELF.Open(Window)                                        ! Open window
  Do DefineListboxStyle
  Window{Prop:Alrt,255} = CtrlShiftP   
  SELF.SetAlerts()
  EnterByTabManager.Init(False)
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?BUTTONCreateColumn
      ThisWindow.Update
         
        SQL.AddColumn('uCustomer',Column,Type,Length,Options)
    OF ?BUTTONAlterColumn
      ThisWindow.Update
        SQL.ErrorShowInDebugView = TRUE   
        IF ~SQL.AlterColumn('uCustomer',Column,Type,Length,Options)
            MESSAGE('error')
        END
        
        
    OF ?BUTTONRemoveColumn
      ThisWindow.Update
        SQL.QueryAddToClipboard = TRUE
        SQL.DropColumn('uCustomer',Column)
        
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
       IF KEYCODE()=CtrlShiftP AND EVENT() = Event:PreAlertKey
          CYCLE
       END
       IF KEYCODE()=CtrlShiftP  
              UD.ShowProcedureInfo('AlterColumn',UD.SetApplicationName('SQLProcedures','DLL'),Window{PROP:Hlp},'04/20/2012 @ 09:38PM','05/04/2012 @ 12:34PM','05/04/2012 @ 12:34PM')  
          CYCLE
       END
  IF EnterByTabManager.TakeEvent()
     RETURN(Level:Notify)
  END
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

!!! <summary>
!!! Generated from procedure template - Window
!!! </summary>
CustomerForm PROCEDURE 

                                        MAP
SaveRecord                                  PROCEDURE(),BYTE 
                                        END
LocEnableEnterByTab  BYTE(1)                               !Used by the ENTER Instead of Tab template
EnterByTabManager    EnterByTabClass
Window               WINDOW('Add Record'),AT(,,293,111),CENTER,GRAY
                       PROMPT('Name:'),AT(61,16),USE(?UCU:Name:Prompt)
                       ENTRY(@s60),AT(90,15,162,10),USE(UCU:Name),LEFT
                       PROMPT('Address:'),AT(54,32),USE(?UCU:Address:Prompt)
                       ENTRY(@s60),AT(90,32,162,10),USE(UCU:Address),LEFT
                       PROMPT('City State Zip:'),AT(41,50),USE(?UCU:CityStateZip:Prompt)
                       ENTRY(@s60),AT(90,50,162,10),USE(UCU:CityStateZip),LEFT
                       PROMPT('Phone:'),AT(60,68),USE(?UCU:Phone:Prompt)
                       ENTRY(@s20),AT(90,67,162,10),USE(UCU:Phone),LEFT
                       BUTTON('OK'),AT(196,88,35,16),USE(?BUTTONOK)
                       BUTTON('Cancel'),AT(234,88,36,16),USE(?BUTTONCancel)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeEvent              PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('CustomerForm')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?UCU:Name:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF UD.ProcedureInfoToDebugView    
        UD.Debug(FORMAT('CustomerForm',@S30) & FORMAT(UD.SetShortApplicationName('SQLProcedures','DLL'),@S20) & ' Last Modified: ' & '05/04/2012 @ 12:34PM') 
  END
  Relate:UCustomer.Open                                    ! File UCustomer used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
        Access:UCustomer.UseFile(UseType:Returns)    
        CASE SELF.Request
        OF InsertRecord
            CLEAR(UCustomer)
        OF ChangeRecord
            
        END
        
  SELF.Open(Window)                                        ! Open window
  Do DefineListboxStyle
  Window{Prop:Alrt,255} = CtrlShiftP   
  SELF.SetAlerts()
  EnterByTabManager.Init(False)
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:UCustomer.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?BUTTONOK
      ThisWindow.Update
        IF SaveRecord() = Level:Benign
            self.SetResponse(RequestCompleted)      !sets and closes window
        END 
        
        
    OF ?BUTTONCancel
      ThisWindow.Update
        self.SetResponse(RequestCancelled) 
        
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
       IF KEYCODE()=CtrlShiftP AND EVENT() = Event:PreAlertKey
          CYCLE
       END
       IF KEYCODE()=CtrlShiftP  
              UD.ShowProcedureInfo('CustomerForm',UD.SetApplicationName('SQLProcedures','DLL'),Window{PROP:Hlp},'04/22/2012 @ 02:11PM','05/04/2012 @ 12:34PM','05/04/2012 @ 12:34PM')  
          CYCLE
       END
  IF EnterByTabManager.TakeEvent()
     RETURN(Level:Notify)
  END
  ReturnValue = PARENT.TakeEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

SaveRecord                              PROCEDURE()   !,BYTE       

    CODE
    
        CASE ThisWindow.Request
        OF InsertRecord
            SQL.Insert(uCustomer,TRUE)
             
        OF ChangeRecord 
            SQL.Update(UCustomer)
        END 
    
        RETURN Level:Benign
